sub get_snmp_http {
	my $PID = shift;
	my $config = shift;

	my $time = shift || time;
	my $actualdate = date($time);
	my $userAgent = LWP::UserAgent->new();
   $userAgent->timeout(10);
	my $response = $userAgent->post($config->server, [
	'get_data' => '1',
	'key' => $config->key,
	'PID' => $PID,
	'date' => $actualdate->{date}." ".$actualdate->{heure}],
	'content_type' => 'multipart/form-data');

if (!$response->is_success) {
   if ($response->content =~ m/(connect: timeout)/) {
      ErrorCode('1001');
   } elsif ($response->content =~ m/(connect: Invalid argument)/) {
      ErrorCode('1004');
   } elsif ($response->content =~ m/500 Connect failed: connect: Connection refused; Connection refused/) {
         ErrorCode('1006');
   } else {
      print $response->error_as_HTML;
   }
   delete_pid();
   exit;
}

	#Debug
	#	print $response->content."\n";

      my $dest = Compress::Zlib::memGunzip($response->content);
   if( ! defined $dest ) {
      if ($response->content =~ m/(connect: timeout)/) {
         ErrorCode('1001');
      } elsif ($response->content =~ m/A link to the Mysql server could not be established/) {
         ErrorCode('1005');
      } else {
         ErrorCode('1003');
      }
      delete_pid();
      exit;
   } else {
      if ($dest eq "Lock"){
         ErrorCode('1007');
         delete_pid();
         exit;
      }elsif ($dest eq "No SSL"){
         ErrorCode('1008');
         delete_pid();
         exit;
      }
      return $dest;
   }
}



sub send_snmp_http {
	my $data_compressed = shift;
	my $PID = shift;
	my $config = shift;

 	$url = $config;
	#print "URL :".$url."\n";
	# Must send file and not by POST
	$userAgent = LWP::UserAgent->new();
	$response = $userAgent->post($url, [
	'upload' => '1',
	'data' => [ undef, $PID.'.xml.gz', Content => $data_compressed ],
	'md5_gzip' => '567894'],
	'content_type' => 'multipart/form-data');

	print $response->error_as_HTML . "\n" if $response->is_error;
   if ($response->content eq "Impossible to copy file in ../../../files/_plugins/tracker/") {
      ErrorCode('1002');
      delete_pid();
      exit;
   }
	print $response->content."\n";
}




sub send_snmp_http_threaded {
   my @args;
	$args[0] = shift;
   $args[1] = shift;
   $args[2] = shift;
   $args[3] = shift;
   $args[4] = shift;
   $args[5] = shift;

	my $data_compressed;

	if ($args[0]) {
		$data_compressed = Compress::Zlib::memGzip($args[0]);
		send_snmp_http($data_compressed,$args[4]."-".$args[2]."-".$args[1]."-".$args[5],$args[3]);
	}
}


1;