# Manage PID and lock of Tracker agent
sub pid_check_lock {
   if (-e "lock.pid") {
      $nbminutes = stat('lock.pid')->mtime;
      $datenow = time;
      $datelimit = time - (60 * 60);

      if ($nbminutes > $datelimit) {
         # If file write < 1h, exit;
         print "Agent is currently running...\n";
         exit;
      } else {
         # If file write > 1h, kill all processes, remove lock
         open (MYFILE, 'lock.pid');
         while (<MYFILE>) {
            chomp;
            kill 9, $_;
         }
         close (MYFILE);
         unlink("lock.pid");
         open (MYFILE, '>lock.pid');
         print MYFILE $$."\n";
         close (MYFILE);
      }
   } else {
      # Create lock.pid file
      open (MYFILE, '>lock.pid');
      print MYFILE $$."\n";
      close (MYFILE);
   }
}

sub write_pid {
      open (MYFILE, '>>lock.pid');
      print MYFILE $$."\n";
      close (MYFILE);
}

sub delete_pid {
   unlink("lock.pid");
}

1;