sub query_threaded {
	my $nb_threads_query = shift;
	my $data = shift;
	my $fragment = shift;
	my $PID = shift;
	my $nb_core_query = shift;
	my $log = shift;
	my $Bin = shift;
	my $config = shift;
	my $config_key = shift;
	my $agent_version = shift;
   my $argnodisplay = shift;
   my $argnoprogressbar = shift;

   my $num_files = 1;
   my $device;

	debug($log,'==== Query ====','',$PID,$Bin);

	#===================================
	# Threads et variables partagées
	#===================================
   my $TuerThread : shared = 0;       # Permet de tuer le thread proprement
	my $NomFonction : shared;         # Contient le nom de la fonction à appeler
	my %ThreadTravail : shared;       # Contient la valeur permettant au thread de lancer une procédure
	my %ArgumentsThread :shared;     # Contient les arguements à passer à une éventuelle procédure
	my %ResultatFonction : shared;    # Contient le résultat des fonctions lancées dans le thread
   my %authSNMP_discovery : shared;
   #my %devicelist : shared;
   my %devicelist;
	my $Thread = ();


	$ArgumentsThread{'id'} = &share([]);
	$ArgumentsThread{'log'} = &share([]);
	$ArgumentsThread{'Bin'} = &share([]);
	$ArgumentsThread{'PID'} = &share([]);
   $ArgumentsThread{'xml'} = &share([]);


   # Dispatch devices to different core
   my $core_counter = 0;
   my %devicelist2;
   my @i;
   my $nbip = 0;

   for(my $j = 0 ; $j < $nb_core_query ; $j++) {
      $i[$j] = 0;
   }

   
   if (ref($data->{device_networking}) eq "HASH"){
		if (defined($data->{device_networking}->{infos}->{id})) {
         if ($core_counter == $nb_core_query) {
				$core_counter = 0;
			}
			$devicelist{$core_counter}{$i[$core_counter]} = $data->{device_networking};
         $devicelist2{$core_counter}{$i[$core_counter]} = 1;
         $i[$core_counter]++;
			$core_counter++;
         $nbip++;
		}
	}else {
		foreach $device (@{$data->{device_networking}}) {
         if ($core_counter == $nb_core_query) {
				$core_counter = 0;
			}
			$devicelist{$core_counter}{$i[$core_counter]} = $device;
         $devicelist2{$core_counter}{$i[$core_counter]} = 1;
			$i[$core_counter]++;
			$core_counter++;
         $nbip++;
		}
	}
   if (ref($data->{device_printer}) eq "HASH"){
		if (defined($data->{device_printer}->{infos}->{id})) {
			if ($core_counter == $nb_core_query) {
				$core_counter = 0;
			}
			$devicelist{$core_counter}{$i[$core_counter]} = $data->{device_printer};
         $devicelist2{$core_counter}{$i[$core_counter]} = 1;
			$i[$core_counter]++;
			$core_counter++;
         $nbip++;
		}
	}else {
		foreach $device (@{$data->{device_printer}}) {
			if ($core_counter == $nb_core_query) {
				$core_counter = 0;
			}
			$devicelist{$core_counter}{$i[$core_counter]} = $device;
         $devicelist2{$core_counter}{$i[$core_counter]} = 1;
         $i[$core_counter]++;
			$core_counter++;
         $nbip++;
		}
	}
   if (!defined $devicelist2{0}{0}) {
		$xml_data = "<snmp>\n</snmp>\n";
		my $data_compressed = Compress::Zlib::memGzip($xml_data);
		#send_snmp_http($data_compressed,$PID."-".$num_files,$config);
		return $num_files;
	}

   #============================================
	# Load progress bar
	#============================================
#   if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#      my %options = (
#         create    => 'yes',
#         exclusive => 0,
#         mode      => 0644,
#         destroy   => 'yes',
#      );
#      my $ipcounter = 0;
#      $ipcshare = tie $ipcounter, 'IPC::Shareable', 'data', { %options } or
#        die "server: tie failed\n";
#      $ipcounter = 0;
#
#      # Create Thread
#      $Thread_progress_bar = threads->create( sub {
#                                              my @spin = ('|','/','-','\\');
#                                              my $i = 0;
#
#                                              $i = ($i+1) % scalar @spin;
#                                              while(1)
#                                              {
#                                                 if ($ipcounter eq "END") {
#                                                    print chr 8;
#                                                    print chr 8;
#                                                     return;
#                                                   }
#                                                   print "[".$ipcounter." / ".$nbip."] ".$spin[$i];
#                                                   sleep 1;
#
#                                                  foreach(my $k=0 ; $k < (length($ipcounter) + length($nbip) + 7) ; $k++) {
#                                                      print chr 8;
#                                                  }
#                                                  $i = ($i+1) % scalar @spin;
#                                              }
#
#                                             return;
#                                          });
#   }
   #============================================
	# Begin ForkManager (multiple core / process)
	#============================================
   $max_procs = $nb_core_query*$nb_threads_query;
	$pm=new Parallel::ForkManager($max_procs);
   
   for(my $p = 0; $p < $nb_core_query; $p++) {
		$pid = $pm->start and next;
      write_pid();
      # Création des threads
      $ThreadTravail{$p} = &share([]);
      $TuerThread{$p} = &share([]);
      for(my $j = 0 ; $j < $nb_threads_query ; $j++) {
         $ThreadTravail{$p}[$j] = 0;               # 0 : thread ne fait rien, 1 : il bosse
         $TuerThread{$p}[$j]    = 0;					# 0 : thread en vie, 1 : thread se termine
      }

      #===================================
      # Create all Threads
      #===================================
      for(my $j = 0; $j < $nb_threads_query; $j++) {
         @args = ($p, $j);
         #$Thread[$p][$j] = threads->create( \&query_thread, \@args);
         $Thread[$p][$j] = threads->create( sub {
                                                   $p = $args[0];
                                                   $t = $args[1];

#                                                   if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#                                                      my $count;
#                                                      tie $count, 'IPC::Shareable', 'data', { 'destroy' => 'Yes!' };
#                                                   }

                                                   while (1) {
                                                      #print $p." - ".$t."\n";
                                                      if ( $ThreadTravail{$p}[$t] == 1 ) {
                                                         #print "[".$p."][".$t."]".$devicelist{$p}[$t]->{infos}->{ip}."\n";
                                                         # Lance la procédure et récupère le résultat
                                                         $tmp = query_device_threaded(
                                                            $devicelist{$p}{$ArgumentsThread{'id'}[$p][$t]},
                                                            $ArgumentsThread{'log'}[$p][$t],
                                                            $ArgumentsThread{'Bin'}[$p][$t],
                                                            $ArgumentsThread{'PID'}[$p][$t],
                                                            $config_key,
                                                            $agent_version)."\n";
                                                         if ($tmp ne "\n") {
                                                            $ArgumentsThread{'xml'}[$p][$t] .= $tmp;
                                                         }

#                                                         if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#                                                            $ipcshare->shlock;
#                                                            $count++;
#                                                            $ipcshare->shunlock;
#                                                         }

                                                         # demande au thread de dormir
                                                         $ThreadTravail{$p}[$t] = 0;
                                                      }

                                                      # Terminer le thread
                                                      last if ( $TuerThread{$p}[$t] == 1 );
                                                      sleep 1;
                                                   }
                                                   return;
                                                }, \@args);
      }

      $j = 0;
      $i = 0;
      $ArgumentsThread{'id'}[$p] = &share([]);
      $ArgumentsThread{'Bin'}[$p] = &share([]);
      $ArgumentsThread{'log'}[$p] = &share([]);
      $ArgumentsThread{'PID'}[$p] = &share([]);
      $ArgumentsThread{'xml'}[$p] = &share([]);

      BOUCLE002: while (my ($device_id, $num) = each %{$devicelist2{$p}}) {
         if ($i < $nb_threads_query) {
            delete ${$devicelist2{$p}}{$device_id};
            #$NomFonction = "discovery_ip_threaded";
            $ArgumentsThread{'id'}[$p][$i] = $device_id;
            $ArgumentsThread{'Bin'}[$p][$i] = $Bin;
            $ArgumentsThread{'log'}[$p][$i] = $log;
            $ArgumentsThread{'PID'}[$p][$i] = $PID;
            $ArgumentsThread{'xml'}[$p][$i] = "";

            $ThreadTravail{$p}[$i] = 1; # On lui demande de bosser
            $i++;
         } else {
            last BOUCLE002;
         }
      }


      while (keys %{$devicelist2{$p}} != 0) {
         for(my $i = 0 ; $i < $nb_threads_query ; $i++) {
            if ($ThreadTravail{$p}[$i] == 0) {
               while (my ($device_id, $num) = each %{$devicelist2{$p}}) {
                  delete ${$devicelist2{$p}}{$device_id};
                  $ArgumentsThread{'id'}[$p][$i] = $device_id;
                  $ThreadTravail{$p}[$i] = 1; # On lui demande de bosser
                  last;
               }
            }
         }
      }

      $xml = '';
      for(my $j = 0; $j < $nb_threads_query; $j++) {
         while ($ThreadTravail{$p}[$j] == 1) {
            sleep 0.2;
         }
         if (exists($ArgumentsThread{'xml'}[$p][$j])) {
            $xml .= $ArgumentsThread{'xml'}[$p][$j];
         }
         $TuerThread{$p}[$j] = 1;
#         $Thread[$p][$j]->detach();
         $Thread[$p][$j]->join();
      }
      send_snmp_http_threaded($xml, $p, "tmp",$config,$PID,$num_files);
#      if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#         $Thread_progress_bar->detach();
#      }
      $pm->finish;
	}
	$pm->wait_all_children;

#   if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#      sleep 2;
#      $ipcounter = "END";
#      $Thread_progress_bar->detach();
#      print "\n";
#   }
	return $num_files;

}

sub query_device_threaded {
	$device = shift;
	$log = shift;
	$Bin = shift;
	$PID = shift;
	$config_key = shift;
	$agent_version = shift;

	#threads->yield;
	$IP = $device->{infos}->{ip};
	$entity = $device->{infos}->{entity};
	$ID = $device->{infos}->{id};
	$type = $device->{infos}->{type};

	debug($log,"[".$device->{infos}->{ip}."] : start Thread", "",$PID,$Bin);

	$snmp_version = $device->{auth}->{version};
	$snmp_community = $device->{auth}->{community};
	$snmp_username = $device->{auth}->{sec_name};
	$snmp_authkey  = $device->{auth}->{authkey};
	$snmp_authpassword = $device->{auth}->{auth_passphrase};
	$snmp_authprotocol = $device->{auth}->{auth_protocol};
	$snmp_privkey = $device->{auth}->{privkey};
	$snmp_privpassword = $device->{auth}->{priv_passphrase};
	$snmp_privprotocol = $device->{auth}->{priv_protocol};

	#debug($log,"IP : $IP", "",$PID,$Bin);

	foreach my $lists (@{$device->{get}}) {
		$SNMPget{$lists->{object}} = $lists->{oid};
		if ($lists->{vlan} == 1) {
			$SNMPgetVlan{$lists->{object}} = $lists->{vlan};
		}
	}

	foreach my $lists (@{$device->{walk}}) {
		$SNMPwalk{$lists->{object}} = $lists->{oid};
		if ($lists->{vlan} == 1) {
			$SNMPwalkVlan{$lists->{object}} = $lists->{vlan};
		}
	}

	############### SNMP Queries ###############
	($session, $error) = start_session($IP,$snmp_version,$snmp_community,$snmp_username,$snmp_authkey,$snmp_authpassword,$snmp_authprotocol,$snmp_privkey,$snmp_privpassword,$snmp_privprotocol,'1');
	if (!defined($session)) {
		debug($log,"[$IP] Error on connection","",$PID,$Bin);
		print("SNMP ERROR: %s.\n", $error);
		return "";
	}
	($session2, $error2) = start_session($IP,$snmp_version,$snmp_community,$snmp_username,$snmp_authkey,$snmp_authpassword,$snmp_authprotocol,$snmp_privkey,$snmp_privpassword,$snmp_privprotocol,'0');

	$error = '';
	# Query for timeout #
	$description = snmpget('.1.3.6.1.2.1.1.1.0',1);
	$insertXML = '';
	if ($description =~ m/No response from remote host/) {
		$error = "No response from remote host";
		%ArraySNMPget = ();
		%ArraySNMPwalk = ();
		debug($log,"[$IP] $error","",$PID,$Bin);
		return "";
	} else {
		# Query SNMP get #
		%ArraySNMP = ();
		while (($object,$oid) = each (%SNMPget)) {
         $oid_result = snmpget($oid);
         if ($oid_result ne "null") {
            $ArraySNMPget{$oid} = $oid_result;
         }
		}
		# Query SNMP walk #
		%ArraySNMP = ();
		while (($object,$oid) = each (%SNMPwalk)) {
			%ArraySNMPwalk = snmpwalk($oid);
		}
		# if $type == 2 alors scanner les VLANS
		# Walk .1.3.6.1.4.1.9.9.46.1.3.1.1.4.1
		# uniquement pour les Cisco
		# Implique de recréer une session spécialement pour chaque vlan : communauté@vlanID
		if ($type == 2) {
			%ArraySNMP = ();
			$description = snmpget('.1.3.6.1.2.1.1.1.0');
			if ($description =~ m/Cisco /) {
            # Get all mac address of switch (switch + ports)

            %ArrayMACAdressTable = snmpwalk($SNMPwalk{"IF-MIB::ifPhysAddress"});
            while (($object,$oid) = each (%ArrayMACAdressTable)) {
               $MACDeny{$oid} = 1;
            }
            # Delete all values on %ArraySNMPwalk where dot1dTpFdbAddress (.1.3.6.1.2.1.17.4.3.1.1)
            # is in $MACDeny
            while (($oid,$mac) = each (%ArraySNMPwalk)) {
               if ($oid =~ /.1.3.6.1.2.1.17.4.3.1.1./) {
                  if (defined $MACDeny{$mac}) {
                    delete($ArraySNMPwalk{$oid});
                  }
               }
            }



				$Array_trunk_ifIndex = cisco_trunk_port(%ArraySNMPwalk);

				debug($log,"[".$device->{infos}->{ip}."] : Vlan : Start", "",$PID,$Bin);
				%ArrayVlans = ();
				%ArraySNMP = ();
				%ArrayVlans = snmpwalk('.1.3.6.1.4.1.9.9.46.1.3.1.1.4.1');
				$session->close;
            $session2->close;

				$vlanArray = ();
				$j = 0;
				while (($oid1,$vlanName) = each (%ArrayVlans)) {
					@vlanID_tmp = split(/\./, $oid1);
					$vlanArray[$j] = $vlanID_tmp[16];
					$j++;
				}
            $j = 0;
            while ($j < scalar(keys %ArrayVlans)) {
               $vlanID = $vlanArray[$j];
               undef $vlanArray[$j];
               $insertXML .= query_device_threaded_vlans($log,$IP,$vlanID,$Array_trunk_ifIndex);
               $j++;
            }
   		}
		}
	}
	debug($log,"[".$device->{infos}->{ip}."] : end Thread", "",$PID,$Bin);
	my $tmp_xml = constructxmlDevice(\%ArraySNMPget,\%ArraySNMPwalk,$IP,$ID,$entity,$error,$agent_version,$config_key,$type,$insertXML,$log,$PID,$Bin);
	return $tmp_xml;
}

sub query_device_threaded_vlans {
#	debug($log,"[".$IP."][Vlan ".$vlanID."] Thread create", "",$PID,$Bin);
#	if ($experimental == 1) {
#		threads->yield;
#	}
#	debug($log,"[".$IP."][Vlan ".$vlanID."] Thread (1)", "",$PID,$Bin);
	($session, $error) = start_session($IP,$snmp_version,$snmp_community."@".$vlanID,$snmp_username,$snmp_authkey,$snmp_authpassword,$snmp_authprotocol,$snmp_privkey,$snmp_privpassword,$snmp_privprotocol,'1');
   ($session2, $error2) = start_session($IP,$snmp_version,$snmp_community."@".$vlanID,$snmp_username,$snmp_authkey,$snmp_authpassword,$snmp_authprotocol,$snmp_privkey,$snmp_privpassword,$snmp_privprotocol,'0');
	%ArraySNMPget_vlan = ();
	%ArraySNMPwalk_vlan = ();
	# Query SNMP get #
	%ArraySNMP = ();

	%ArraySNMPwalk_vlan = cisco_vlans(%ArraySNMPwalk,$Array_trunk_ifIndex);

	$session->close;
   $session2->close;
	$insertXML_tmp = constructxmlGetWalkVlan(\%ArraySNMPget_vlan,\%ArraySNMPwalk_vlan,$vlanID);
	return $insertXML_tmp;
}

1;